# Biblioteca de estilo da família OKTO


## O que é?
Extensão do Bootstrap 4 modificado para se parecer com o [wireframe do Okto](https://oo758l.axshare.com) porém **sem modificar suas marcações de HTML originais**. Por se tratar de uma extensão, tudo disponível na [documentação do Bootstrap 4](https://getbootstrap.com/docs/4.0/getting-started/contents/) poderá ser usado normalmente no projeto, além dos novos comportamentos aqui adicionados.


-------------


## Arquitetura

### Estrutura
TODO

### Build
A build do scss é realizado apenas com node através dos `scripts` do package.json.

### Documentação
A documentação é gerada pelo [kss-node](https://github.com/kss-node/kss-node) automaticamente a partir dos comentários dos arquivos `.scss`.

### Regras
1. Todo componente deverá ser **agnóstico de Javascript**;
2. Todo componente não deverá possuir **regras de negócio**;
3. Todo componente deverá ter todos os seus **comportamentos documentados**;


-------------


## Como contribuir?

### Quero adicionar um novo componente:
1. Crie uma branch com o nome do componente com todo o código e documentação do mesmo;
2. Faça um [merge request](https://scm.atech.com.br/atech-style/oktostrap/merge_requests) para a master no gitlab;
3. Avise outro front-ender que utiliza a biblioteca para fazer o code-review do seu código e aceitar ou reprovar o commit seguindo as [Regras do merge request](#regras-do-merge-request);

### Quero corrigir um bug ou modificar um comportamento
1. Vá para branch **dev**
2. Altere o código que desejar
3. Faça um [merge request](https://scm.atech.com.br/atech-style/oktostrap/merge_requests) para a master no gitlab;
4. Avise outro front-ender que utiliza a biblioteca para fazer o code-review do seu código e aceitar ou reprovar o commit seguindo as [Regras do merge request](#regras-do-merge-request);


-------------


## Regras do merge request
Antes de aceitar qualquer merge request verifique se ele está de acordo com as seguintes premissas:

1. Verifique se a **nomeclatura** do componente está clara e condizente com o que ele se propõe; 
2. Verifique se o componente está usando **váriaveis**, **mixins** e **functions** corretamente;
3. Verifique se o componente está devidamente **documentado**;
4. Verifique como o componente se comporta em diferentes **resoluções**;
